"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var functions = require("firebase-functions");
var ow_1 = require("ow");
var FirebaseFunctionsRateLimiterConfiguration_1 = require("./FirebaseFunctionsRateLimiterConfiguration");
var GenericRateLimiter_1 = require("./GenericRateLimiter");
var FirestorePersistenceProvider_1 = require("./persistence/FirestorePersistenceProvider");
var PersistenceProviderMock_1 = require("./persistence/PersistenceProviderMock");
var RealtimeDbPersistenceProvider_1 = require("./persistence/RealtimeDbPersistenceProvider");
var FirebaseTimestampProvider_1 = require("./timestamp/FirebaseTimestampProvider");
var FirebaseFunctionsRateLimiter = /** @class */ (function () {
    function FirebaseFunctionsRateLimiter(configuration, persistenceProvider) {
        this.configurationFull = __assign({}, FirebaseFunctionsRateLimiterConfiguration_1.FirebaseFunctionsRateLimiterConfiguration.DEFAULT_CONFIGURATION, configuration);
        ow_1.default(this.configurationFull, "configuration", ow_1.default.object);
        FirebaseFunctionsRateLimiterConfiguration_1.FirebaseFunctionsRateLimiterConfiguration.ConfigurationFull.validate(this.configurationFull);
        this.debugFn = this.constructDebugFn(this.configurationFull);
        persistenceProvider.setDebugFn(this.debugFn);
        var timestampProvider = new FirebaseTimestampProvider_1.FirebaseTimestampProvider();
        this.genericRateLimiter = new GenericRateLimiter_1.GenericRateLimiter(this.configurationFull, persistenceProvider, timestampProvider, this.debugFn);
    }
    /*
     * Factories
     */
    FirebaseFunctionsRateLimiter.withFirestoreBackend = function (configuration, firestore) {
        var provider = new FirestorePersistenceProvider_1.FirestorePersistenceProvider(firestore);
        return new FirebaseFunctionsRateLimiter(configuration, provider);
    };
    FirebaseFunctionsRateLimiter.withRealtimeDbBackend = function (configuration, realtimeDb) {
        var provider = new RealtimeDbPersistenceProvider_1.RealtimeDbPersistenceProvider(realtimeDb);
        return new FirebaseFunctionsRateLimiter(configuration, provider);
    };
    FirebaseFunctionsRateLimiter.mock = function (configuration, persistenceProviderMock) {
        var defaultConfig = {
            periodSeconds: 10,
            maxCalls: Number.MAX_SAFE_INTEGER,
        };
        /* istanbul ignore next */
        var provider = persistenceProviderMock || new PersistenceProviderMock_1.PersistenceProviderMock();
        /* istanbul ignore next */
        return new FirebaseFunctionsRateLimiter(configuration || defaultConfig, provider);
    };
    /* istanbul ignore next because this method was renamed and is now deprecated */
    /**
     * Checks if quota is exceeded. If not — records usage time in the backend database.
     * The method is deprecated as it was renamed to isQuotaExceededOrRecordUsage
     *
     * @param qualifier — a string that identifies the limited resource accessor (for example the user id)
     * @deprecated
     */
    FirebaseFunctionsRateLimiter.prototype.isQuotaExceeded = function (qualifier) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.isQuotaExceededOrRecordUsage(qualifier)];
            });
        });
    };
    /* istanbul ignore next because this method was renamed and is now deprecated */
    /**
     * Checks if quota is exceeded. If not — records usage time in the backend database.
     *
     * @param qualifier — a string that identifies the limited resource accessor (for example the user id)
     * @deprecated
     */
    FirebaseFunctionsRateLimiter.prototype.isQuotaExceededOrRecordUsage = function (qualifier) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.genericRateLimiter.isQuotaExceededOrRecordCall(qualifier || FirebaseFunctionsRateLimiter.DEFAULT_QUALIFIER)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /* istanbul ignore next because this method was renamed and is now deprecated */
    /**
     * Checks if quota is exceeded. If not — records usage time in the backend database and then
     * is rejected with functions.https.HttpsError (this is the type of error that can be caught when
     * firebase function is called directly: see https://firebase.google.com/docs/functions/callable)
     * The method is deprecated as it was renamed to rejectOnQuotaExceededOrRecordUsage
     *
     * @param qualifier  — a string that identifies the limited resource accessor (for example the user id)
     * @deprecated
     */
    FirebaseFunctionsRateLimiter.prototype.rejectOnQuotaExceeded = function (qualifier) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rejectOnQuotaExceededOrRecordUsage(qualifier)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Checks if quota is exceeded. If not — records usage time in the backend database and then
     * is rejected with functions.https.HttpsError (this is the type of error that can be caught when
     * firebase function is called directly: see https://firebase.google.com/docs/functions/callable)
     *
     * @param qualifier (optional) — a string that identifies the limited resource accessor (for example the user id)
     * @param errorFactory (optional) — when errorFactory is provided, it is used to obtain
     *                                  error that is thrown in case of exceeded limit.
     */
    FirebaseFunctionsRateLimiter.prototype.rejectOnQuotaExceededOrRecordUsage = function (qualifier, errorFactory) {
        return __awaiter(this, void 0, void 0, function () {
            var isExceeded;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.genericRateLimiter.isQuotaExceededOrRecordCall(qualifier || FirebaseFunctionsRateLimiter.DEFAULT_QUALIFIER)];
                    case 1:
                        isExceeded = _a.sent();
                        if (isExceeded) {
                            if (errorFactory)
                                throw errorFactory(this.getConfiguration());
                            else
                                throw this.constructRejectionError(qualifier);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Checks if quota is exceeded. If not — DOES NOT RECORD USAGE. It only checks if limit was
     * previously exceeded or not.
     * @param qualifier — a string that identifies the limited resource accessor (for example the user id)
     */
    FirebaseFunctionsRateLimiter.prototype.isQuotaAlreadyExceeded = function (qualifier) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.genericRateLimiter.isQuotaAlreadyExceededDoNotRecordCall(qualifier || FirebaseFunctionsRateLimiter.DEFAULT_QUALIFIER)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Returns this rate limiter configuration
     */
    FirebaseFunctionsRateLimiter.prototype.getConfiguration = function () {
        return this.configurationFull;
    };
    /*
     * Private methods
     */
    FirebaseFunctionsRateLimiter.prototype.constructRejectionError = function (qualifier) {
        var c = this.configurationFull;
        var msg = "FirebaseFunctionsRateLimiter error: Limit of " + c.maxCalls + " calls per " +
            (c.periodSeconds + " seconds exceeded for " + (qualifier ? "specified qualifier in " : "")) +
            ("limiter " + c.name);
        return new functions.https.HttpsError("resource-exhausted", msg);
    };
    FirebaseFunctionsRateLimiter.prototype.constructDebugFn = function (config) {
        /* istanbul ignore if */
        if (config.debug)
            return function (msg) { return console.log(msg); };
        else {
            return function (msg) {
                /* */
            };
        }
    };
    FirebaseFunctionsRateLimiter.DEFAULT_QUALIFIER = "default_qualifier";
    return FirebaseFunctionsRateLimiter;
}());
exports.FirebaseFunctionsRateLimiter = FirebaseFunctionsRateLimiter;
//# sourceMappingURL=FirebaseFunctionsRateLimiter.js.map