"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ow_1 = require("ow");
var FirebaseFunctionsRateLimiterConfiguration;
(function (FirebaseFunctionsRateLimiterConfiguration) {
    var ConfigurationFull;
    (function (ConfigurationFull) {
        function validate(o) {
            ow_1.default(o.name, "configuration.name", ow_1.default.string.nonEmpty);
            ow_1.default(o.periodSeconds, "configuration.periodSeconds", ow_1.default.number.integer.finite.greaterThan(0));
            ow_1.default(o.maxCalls, "configuration.maxCalls", ow_1.default.number.integer.finite.greaterThan(0));
            ow_1.default(o.debug, "configuration.debug", ow_1.default.boolean);
        }
        ConfigurationFull.validate = validate;
    })(ConfigurationFull = FirebaseFunctionsRateLimiterConfiguration.ConfigurationFull || (FirebaseFunctionsRateLimiterConfiguration.ConfigurationFull = {}));
    FirebaseFunctionsRateLimiterConfiguration.DEFAULT_CONFIGURATION = {
        name: "rlimit",
        periodSeconds: 5 * 60,
        maxCalls: 5,
        debug: false,
    };
})(FirebaseFunctionsRateLimiterConfiguration = exports.FirebaseFunctionsRateLimiterConfiguration || (exports.FirebaseFunctionsRateLimiterConfiguration = {}));
//# sourceMappingURL=FirebaseFunctionsRateLimiterConfiguration.js.map