import { FirebaseFunctionsRateLimiterConfiguration } from "./FirebaseFunctionsRateLimiterConfiguration";
import { PersistenceProvider } from "./persistence/PersistenceProvider";
import { TimestampProvider } from "./timestamp/TimestampProvider";
export declare class GenericRateLimiter {
    private configuration;
    private persistenceProvider;
    private timestampProvider;
    private debugFn;
    constructor(configuration: FirebaseFunctionsRateLimiterConfiguration, persistenceProvider: PersistenceProvider, timestampProvider: TimestampProvider, debugFn?: (msg: string) => void);
    isQuotaExceededOrRecordCall(qualifier: string): Promise<boolean>;
    isQuotaAlreadyExceededDoNotRecordCall(qualifier: string): Promise<boolean>;
    private runTransactionForAnswer;
    private selectRecentUsages;
    private isQuotaExceeded;
    private getTimestampsSeconds;
}
