"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ow_1 = require("ow");
var FirebaseFunctionsRateLimiterConfiguration_1 = require("./FirebaseFunctionsRateLimiterConfiguration");
var GenericRateLimiter = /** @class */ (function () {
    function GenericRateLimiter(configuration, persistenceProvider, timestampProvider, debugFn) {
        if (debugFn === void 0) { debugFn = function (msg) {
            /* */
        }; }
        this.configuration = __assign({}, FirebaseFunctionsRateLimiterConfiguration_1.FirebaseFunctionsRateLimiterConfiguration.DEFAULT_CONFIGURATION, configuration);
        ow_1.default(this.configuration, "configuration", ow_1.default.object);
        FirebaseFunctionsRateLimiterConfiguration_1.FirebaseFunctionsRateLimiterConfiguration.ConfigurationFull.validate(this.configuration);
        this.persistenceProvider = persistenceProvider;
        ow_1.default(this.persistenceProvider, "persistenceProvider", ow_1.default.object);
        this.timestampProvider = timestampProvider;
        ow_1.default(this.timestampProvider, "timestampProvider", ow_1.default.object);
        this.debugFn = debugFn;
    }
    GenericRateLimiter.prototype.isQuotaExceededOrRecordCall = function (qualifier) {
        return __awaiter(this, void 0, void 0, function () {
            var resultHolder;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resultHolder = {
                            isQuotaExceeded: false,
                        };
                        return [4 /*yield*/, this.persistenceProvider.updateAndGet(this.configuration.name, qualifier, function (record) {
                                return _this.runTransactionForAnswer(record, resultHolder);
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, resultHolder.isQuotaExceeded];
                }
            });
        });
    };
    GenericRateLimiter.prototype.isQuotaAlreadyExceededDoNotRecordCall = function (qualifier) {
        return __awaiter(this, void 0, void 0, function () {
            var timestampsSeconds, record, recentUsages;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        timestampsSeconds = this.getTimestampsSeconds();
                        return [4 /*yield*/, this.persistenceProvider.get(this.configuration.name, qualifier)];
                    case 1:
                        record = _a.sent();
                        recentUsages = this.selectRecentUsages(record.u, timestampsSeconds.threshold);
                        return [2 /*return*/, this.isQuotaExceeded(recentUsages.length)];
                }
            });
        });
    };
    GenericRateLimiter.prototype.runTransactionForAnswer = function (input, resultHolder) {
        var timestampsSeconds = this.getTimestampsSeconds();
        this.debugFn("Got record with usages " + input.u.length);
        var recentUsages = this.selectRecentUsages(input.u, timestampsSeconds.threshold);
        this.debugFn("Of these usages there are" + recentUsages.length + " usages that count into period");
        var result = this.isQuotaExceeded(recentUsages.length);
        resultHolder.isQuotaExceeded = result;
        this.debugFn("The result is quotaExceeded=" + result);
        if (!result) {
            this.debugFn("Quota was not exceeded, so recording a usage at " + timestampsSeconds.current);
            recentUsages.push(timestampsSeconds.current);
        }
        var newRecord = {
            u: recentUsages,
        };
        return newRecord;
    };
    GenericRateLimiter.prototype.selectRecentUsages = function (allUsages, timestampThresholdSeconds) {
        var recentUsages = [];
        for (var _i = 0, allUsages_1 = allUsages; _i < allUsages_1.length; _i++) {
            var usageTime = allUsages_1[_i];
            if (usageTime > timestampThresholdSeconds) {
                recentUsages.push(usageTime);
            }
        }
        return recentUsages;
    };
    GenericRateLimiter.prototype.isQuotaExceeded = function (numOfRecentUsages) {
        return numOfRecentUsages >= this.configuration.maxCalls;
    };
    GenericRateLimiter.prototype.getTimestampsSeconds = function () {
        var currentServerTimestampSeconds = this.timestampProvider.getTimestampSeconds();
        return {
            current: currentServerTimestampSeconds,
            threshold: currentServerTimestampSeconds - this.configuration.periodSeconds,
        };
    };
    return GenericRateLimiter;
}());
exports.GenericRateLimiter = GenericRateLimiter;
//# sourceMappingURL=GenericRateLimiter.js.map