import { FirestoreEquivalent } from "../types/FirestoreEquivalent";
import { PersistenceProvider } from "./PersistenceProvider";
import { PersistenceRecord } from "./PersistenceRecord";
export declare class FirestorePersistenceProvider implements PersistenceProvider {
    private firestore;
    private debugFn;
    constructor(firestore: FirestoreEquivalent, debugFn?: (msg: string) => void);
    updateAndGet(collectionName: string, recordName: string, updaterFn: (record: PersistenceRecord) => PersistenceRecord): Promise<PersistenceRecord>;
    get(collectionName: string, recordName: string): Promise<PersistenceRecord>;
    setDebugFn(debugFn: (msg: string) => void): void;
    private runTransaction;
    private getRecord;
    private saveRecord;
    private getDocumentRef;
    private createEmptyRecord;
    private hasRecordChanged;
}
