"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ow_1 = require("ow");
var PersistenceRecord_1 = require("./PersistenceRecord");
var FirestorePersistenceProvider = /** @class */ (function () {
    /* istanbul ignore next (debugFn), because typescript injects if for default parameters */
    function FirestorePersistenceProvider(firestore, debugFn) {
        if (debugFn === void 0) { debugFn = function (msg) {
            /* */
        }; }
        this.firestore = firestore;
        ow_1.default(this.firestore, "firestore", ow_1.default.object);
        this.debugFn = debugFn;
    }
    FirestorePersistenceProvider.prototype.updateAndGet = function (collectionName, recordName, updaterFn) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.runTransaction(function () { return __awaiter(_this, void 0, void 0, function () {
                            var record, updatedRecord;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.getRecord(collectionName, recordName)];
                                    case 1:
                                        record = _a.sent();
                                        updatedRecord = updaterFn(record);
                                        if (!this.hasRecordChanged(record, updatedRecord)) return [3 /*break*/, 3];
                                        return [4 /*yield*/, this.saveRecord(collectionName, recordName, updatedRecord)];
                                    case 2:
                                        _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        result = updatedRecord;
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        /* istanbul ignore next */
                        if (!result)
                            throw new Error("FirestorePersistenceProvider: Persistence record could not be updated");
                        return [2 /*return*/, result];
                }
            });
        });
    };
    FirestorePersistenceProvider.prototype.get = function (collectionName, recordName) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getRecord(collectionName, recordName)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FirestorePersistenceProvider.prototype.setDebugFn = function (debugFn) {
        this.debugFn = debugFn;
    };
    FirestorePersistenceProvider.prototype.runTransaction = function (asyncTransactionFn) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.firestore.runTransaction(function (transaction) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, asyncTransactionFn()];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    FirestorePersistenceProvider.prototype.getRecord = function (collectionName, recordName) {
        return __awaiter(this, void 0, void 0, function () {
            var docSnapshot, record;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getDocumentRef(collectionName, recordName).get()];
                    case 1:
                        docSnapshot = _a.sent();
                        this.debugFn("Got record from collection=" + collectionName + ", document=" + recordName);
                        if (!docSnapshot.exists)
                            return [2 /*return*/, this.createEmptyRecord()];
                        record = docSnapshot.data();
                        PersistenceRecord_1.PersistenceRecord.validate(record);
                        return [2 /*return*/, record];
                }
            });
        });
    };
    FirestorePersistenceProvider.prototype.saveRecord = function (collectionName, recordName, record) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.debugFn("Save record collection=" + collectionName + ", document=" + recordName);
                        return [4 /*yield*/, this.getDocumentRef(collectionName, recordName).set(record)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FirestorePersistenceProvider.prototype.getDocumentRef = function (collectionName, recordName) {
        return this.firestore.collection(collectionName).doc(recordName);
    };
    FirestorePersistenceProvider.prototype.createEmptyRecord = function () {
        return {
            u: [],
        };
    };
    FirestorePersistenceProvider.prototype.hasRecordChanged = function (oldRecord, newRecord) {
        if (oldRecord.u.length !== newRecord.u.length) {
            return true;
        }
        else {
            var a1 = oldRecord.u.concat().sort();
            var a2 = newRecord.u.concat().sort();
            for (var i = 0; i < a1.length; i++) {
                if (a1[i] !== a2[i])
                    return true;
            }
            return false;
        }
    };
    return FirestorePersistenceProvider;
}());
exports.FirestorePersistenceProvider = FirestorePersistenceProvider;
//# sourceMappingURL=FirestorePersistenceProvider.js.map