import { RealtimeDbEquivalent } from "../types/RealtimeDbEquivalent";
import { PersistenceProvider } from "./PersistenceProvider";
import { PersistenceRecord } from "./PersistenceRecord";
export declare class RealtimeDbPersistenceProvider implements PersistenceProvider {
    private database;
    private debugFn;
    constructor(database: RealtimeDbEquivalent, debugFn?: (msg: string) => void);
    updateAndGet(collectionName: string, recordName: string, updaterFn: (record: PersistenceRecord) => PersistenceRecord): Promise<PersistenceRecord>;
    get(collectionName: string, recordName: string): Promise<PersistenceRecord>;
    setDebugFn(debugFn: (msg: string) => void): void;
    private wrapUpdaterFn;
    private getDatabaseRef;
    private createEmptyRecord;
}
