"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ow_1 = require("ow");
var RealtimeDbPersistenceProvider = /** @class */ (function () {
    /* istanbul ignore next (debugFn), because typescript injects if for default parameters */
    function RealtimeDbPersistenceProvider(database, debugFn) {
        if (debugFn === void 0) { debugFn = function (msg) {
            /* */
        }; }
        this.database = database;
        ow_1.default(this.database, "database", ow_1.default.object);
        this.debugFn = debugFn;
    }
    RealtimeDbPersistenceProvider.prototype.updateAndGet = function (collectionName, recordName, updaterFn) {
        return __awaiter(this, void 0, void 0, function () {
            var ref, response, snapshot, committed, data;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ref = this.getDatabaseRef(collectionName, recordName);
                        return [4 /*yield*/, ref.transaction(function (dataToUpdate) { return _this.wrapUpdaterFn(updaterFn)(dataToUpdate); })];
                    case 1:
                        response = _a.sent();
                        snapshot = response.snapshot, committed = response.committed;
                        /* istanbul ignore next because this is not testable locally */
                        if (!snapshot)
                            throw new Error("RealtimeDbPersistenceProvider: realtime db didn't respond with data");
                        /* istanbul ignore next because this is not testable locally */
                        if (!committed)
                            throw new Error("RealtimeDbPersistenceProvider: could not save data");
                        data = snapshot.val();
                        if (data === null)
                            return [2 /*return*/, this.createEmptyRecord()];
                        else
                            return [2 /*return*/, data];
                        return [2 /*return*/];
                }
            });
        });
    };
    RealtimeDbPersistenceProvider.prototype.get = function (collectionName, recordName) {
        return __awaiter(this, void 0, void 0, function () {
            var snapshot, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getDatabaseRef(collectionName, recordName).once("value")];
                    case 1:
                        snapshot = _a.sent();
                        data = snapshot.val();
                        if (data === null)
                            return [2 /*return*/, this.createEmptyRecord()];
                        else
                            return [2 /*return*/, data];
                        return [2 /*return*/];
                }
            });
        });
    };
    RealtimeDbPersistenceProvider.prototype.setDebugFn = function (debugFn) {
        this.debugFn = debugFn;
    };
    RealtimeDbPersistenceProvider.prototype.wrapUpdaterFn = function (updaterFn) {
        var _this = this;
        return function (data) {
            _this.debugFn("RealtimeDbPersistenceProvider: updateFn called with data of type" + typeof data);
            if (data === null) {
                var emptyRecord = _this.createEmptyRecord();
                var updatedPr = updaterFn(emptyRecord);
                return updatedPr;
            }
            else {
                var updatedPr = updaterFn(data);
                return updatedPr;
            }
        };
    };
    RealtimeDbPersistenceProvider.prototype.getDatabaseRef = function (collectionName, recordName) {
        var refName = collectionName + "/" + recordName;
        return this.database.ref(refName);
    };
    RealtimeDbPersistenceProvider.prototype.createEmptyRecord = function () {
        return {
            u: [],
        };
    };
    return RealtimeDbPersistenceProvider;
}());
exports.RealtimeDbPersistenceProvider = RealtimeDbPersistenceProvider;
//# sourceMappingURL=RealtimeDbPersistenceProvider.js.map